######################################################
### Semana Academica - 2012 ##########################
######################################################

dados = read.csv(file="/Users/hudsontorrent/Documents/Education/Aulas/SAECO/wage1.csv",header=T)

reg = lm(wage~female+educ+exper+tenure,data=dados)
summary(reg)

### Heterocedasticidade ###

library(lmtest)
library(car)

# Teste #
bptest(reg)

# Dp's robustos #
cov.rob = hccm(reg,type="hc0")
coeftest(reg,cov.rob)

#####################################################
### Variaveis Instrumentais #########################
#####################################################

library(AER)

dados2 = read.csv(file="/Users/hudsontorrent/Documents/Education/Aulas/SAECO/mroz.csv",header=T)

reg.iv = ivreg(lwage~educ+exper+expersq|exper+expersq+fatheduc+motheduc,data=dados2)
reg.lm = lm(lwage~educ+exper+expersq,data=dados2)

summary(reg.iv)
summary(reg)

# Note a diferenca entre os coeficientes estimados para educ #



#####################################################

n = nrow(dados)

X = cbind(uns=rep(1,n),female=dados$female,educ=dados$educ,exper=dados$exper,tenure=dados$tenure,deparse.level=2)
y = dados$wage

betas = as.vector(solve(t(X)%*%X)%*%t(X)%*%y)

yh = X%*%betas

eh = as.vector(y-yh)

k = ncol(X)
sig.2 = sum(eh^2)/(n-k)

cov.beta = sig.2*solve(t(X)%*%X)

dp.beta = sqrt(diag(cov.beta))

tvalue = betas/dp.beta

p.value = 2*pt(q=abs(tvalue),df=n-k,lower.tail=F)

cbind(betas,dp.beta,tvalue,p.value,deparse.level=2)


######################################################
### Dp's robustos a heterocedasticidade ##############
######################################################

library(lmtest)
library(car)

# Teste #
bptest(reg)

estu = eh/sd(eh)
reg.het = lm(I(estu^2)~0+female+educ+exper+tenure,data=dados)
R.2 = summary(reg.het)$r.squared
est.test.bp = n*R.2

pvalue.bp = pchisq(q=est.test.bp,df=4,lower.tail=F) 

rbind(est.test.bp,pvalue.bp)

cov.rob = hccm(reg,type="hc0")
coeftest(reg,cov.rob)

######################################################

om = diag(eh^2)

covb.rob = solve(t(X)%*%X)%*%(t(X)%*%om%*%X)%*%solve(t(X)%*%X)

dp.beta.r = sqrt(diag(covb.rob))

tvalue.r = betas/dp.beta.r

p.value.r = 2*pt(q=abs(tvalue.r),df=n-k,lower.tail=F)

cbind(betas,dp.beta.r,tvalue.r,p.value.r,deparse.level=2)
