library(tseries)

dado = read.csv(file="/Users/hudsontorrent/Documents/Education/Aulas/SAECO/greene18_1.csv",header=T)

y = dado$YIELD

plot.ts(y)

## Identificacao de modelos ###

#acf(y)
#acf(y,"partial")

quartz() 
par(mfrow=c(1,2))
acf(y, main="ACF",xaxp=c(0,20,20),xlim=c(1,20))       # grafico sem o lag 0
pacf(y, main="PACF",xaxp = c(0,20,20),xlim=c(1,20))

## Estimacao ###

reg = arima(y,order=c(2,0,0))
reg

res = reg$residuals
## Diagnostico dos residuos ##

quartz() 
par(mfrow=c(1,2))
acf(res, main="ACF",xaxp=c(0,20,20),xlim=c(1,20))       # grafico sem o lag 0
pacf(res, main="PACF",xaxp = c(0,20,20),xlim=c(1,20))


Box.test(res,lag=20,type=c("Ljung-Box"))
quartz()
tsdiag(reg)

res.p = (res-mean(res))/sd(res)

jarque.bera.test(res.p)

a = seq(-3,3,by=0.05)
plot(density(res.p,bw=1.5*bw.nrd(res.p)))
lines(a,dnorm(a),col=2)


## Criterios de selecao ##

AIC(reg,k=2)
AIC(reg,k=log(length(y)))		#BIC

## Previsao ###

previsao = predict(reg,n.ahead=3)

##
ys = y[1:58]
reg2 = arima(ys-mean(ys),order=c(2,0,0),include.mean=F); reg2

b1 = as.numeric(reg2$coef[1]); b1
b2 = as.numeric(reg2$coef[2]); b2
b0 = as.numeric((1 - b1 - b2)*mean(ys)); b0

## 1 passo a frente ##

yt1 = b0 + b1*y[58] + b2*y[57];yt1
et1 = y[59] - yt1; et1

## 2 passos a frente ###

yt2 = b0 + b1*yt1 + b2*y[58]; yt2
et2 = y[60] - yt2; et2

## funcao pronta ##
predict(reg2,2)$pred + mean(ys)
##

#########################
### Simulacao ###########
#########################


xs = arima.sim(n = 250, list(order = c(0,0,2),ma = c(0.65,0.24)), sd = 1)

quartz()
plot(xs)


quartz() 
par(mfrow=c(1,2))
acf(xs, main="ACF",xaxp=c(1,20,10))
pacf(xs, main="PACF",xaxp=c(1,20,10))



